'-- SayNewComPort.bas ------------------------------------------- >>fst'18<< -
' - Determines new attached comport. 
' - Outputs number of a new attached comport as errorlevel. 
' - Compiler: FreeBasic (tested with Version 0.24)
'             compiled as Windows console program
'-- V 20180325 -------------------------------- http://www.FrankSteinberg.de -

Declare Function FindComPort() As Integer
Dim Shared sParameter As String 
Dim iResult As Integer 

'*** Get comport name, by determine all available ports in a first run
'    then wait for a newly added port, which is the one to use:   

sParameter = LCase(Right(Command(1), 1))
If sParameter <> "b" Then
	 Print
  Print "SayNewComPort       V20180325           www.FrankSteinberg.de        >>fst'18<<"
  Print
  Print " - Determines new attached USB-ComPorts."
  'Print " - or terminate with [Esc]." 
  Print " - Added portnumber will be emitted as errorlevel."
  Print " - Call with parameter /b to run in batch mode without user interface." 
  Print
  Print " Waiting for new ComPort ...                (press [Esc] to terminate)"     
EndIf

iResult = FindComPort()

If sParameter <> "b" Then
	If iResult > 256 Then 
		 Print " Terminated by user!"
	Else
		 Print
		 Print " Found new attached ComPort:   COM" + Str(iResult)
	EndIf
	Print " Press a key to end."
	Sleep
EndIf

End(iResult)


Function FindComPort() As Integer

 Dim sKey As String
 Dim iPortErr As Integer
 Dim i As Integer
 Dim sPortNr As String
 Dim iFirstrun(1 To 256) As Integer
 
 '*** Get state of comports (iFirstrun(i)=0 if port available):
 For i = 1 To 256 
 	 sPortNr = "COM" +Trim(Str(i),Any Chr(32))
   iFirstrun(i) = Open COM (sPortNr + ":2400,N,8,1,BIN,Cs0,Ds0,Cd0,RS" For Binary As #1)
   Close #1
 Next
 
 '*** Wait for new attached comport:
 Do
		 For i = 1 To 256
			 	sPortNr="COM" +Trim(Str(i),Any Chr(32))
			  iPortErr = Open COM (sPortNr + ":2400,N,8,1,BIN,Cs0,Ds0,Cd0,RS" For Binary As #1)
			  Close #1
			  If iFirstrun(i) - iPortErr > 0 Then  '>0 means: new port, <0 means: port removed, =0 means: no change   
			  	Return i                            'return  comport-number
			  	Exit Do                             'first find ends program
			  EndIf
			  If iFirstrun(i) - iPortErr < 0 Then  '>0 means: new port, <0 means: port removed, =0 means: no change 
			   iFirstrun(i) = iPortErr             'modify state if a comport is removed 
			   If sParameter <> "b" Then
			   	Print " COM" ; Str(i) ; " removed; still waiting ..." 
			   EndIf
			  EndIf
		 Next
		 Sleep 100
		 sKey = InKey
 Loop Until sKey = Chr(27)                'user can abort program with Escape key
 
 '*** Return zero after user break: 
 If sKey = Chr(27) Then Return 999
	
End Function
